<?php

namespace App\Controllers\Admin;

use App\Controllers\BaseController;
use App\Models\Classes;
use App\Models\Subjects;
use App\Models\Question_details;
use App\Models\Questions;
use CodeIgniter\I18n\Time;
use App\Models\Exams;
use App\Models\Resultflag;
use App\Models\Scores;

class Exam extends BaseController
{
    public function index()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        echo view('admin/include/header');
        echo view('admin/exam-settings');
        echo view('admin/include/footer');
    }

    public function load_question()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }
        $request = \Config\Services::request();
        if ($request->getMethod() == 'post') {

            $quest_details = [
                'type' => $request->getVar('examtype'),
                'session' => $request->getVar('session'),
                'term' => $request->getVar('term'),
                'class' => $request->getVar('class'),
                'subject' => $request->getVar('subject')
            ];
            //
            //Initialize session
            $session = session();
            $session->set($quest_details);
            //
            if (session()->get('type')) {
                return redirect()->to(base_url() . '/admin/exam/load_method');
            }
        }
        $classes = new Classes();
        $subjects = new Subjects();
        //
        $cbuilder = $classes->builder();
        $sbuilder = $subjects->builder();
        //
        $cbuilder->select('*');
        $cbuilder->where('school_id', session()->get('schid'));
        $allclass = $cbuilder->get()->getResult();
        //
        $sbuilder->select('*');
        $sbuilder->where('school_id', session()->get('schid'));
        $allsubject = $sbuilder->get()->getResult();
        //

        $data = [
            'classes' => $allclass,
            'subjects' => $allsubject
        ];

        //
        echo view('admin/include/header', $data);
        echo view('admin/load-question');
        echo view('admin/include/footer');
    }

    public function load_method()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        if (!session()->get('type') || !session()->get('session') || !session()->get('class') || !session()->get('term') || !session()->get('subject')) {
            return redirect()->to(base_url() . '/admin/exam/load_question');
        }
        $request = \Config\Services::request();
        //
        if ($request->getMethod() == 'post') {
            helper(['form', 'text']);
            //
            $input_excel = $this->validate([
                'file' => 'uploaded[file]|max_size[file,1024]|ext_in[file,csv],'
            ]);
            //
            if (!$input_excel) { // Not valid
                $iserror = array('code' => '100', 'status' => 'error', 'msg' => $this->validator->listErrors());

                echo json_encode($iserror);
            } else {
                if ($file = $request->getFile('file')) {
                    if ($file->isValid() && !$file->hasMoved()) {

                        // Get random file name
                        $newName = $file->getRandomName();
                        // Store file in public/csvfile/ folder
                        $file->move('./uploads/csvfile', $newName);
                        // Reading file
                        $file = fopen("./uploads/csvfile/" . $newName, "r");
                        $i = 0;
                        $numberOfFields = 8; // Total number of fields
                        $importData_arr = array();
                        //
                        // Initialize $importData_arr Array
                        while (($filedata = fgetcsv($file, 1000, ",")) !== FALSE) {
                            $num = count($filedata);
                            // Skip first row &amp; check number of fields
                            if ($i > 0 && $num == $numberOfFields) {
                                // Key names are the insert table field names - name, email, city, and status
                                $importData_arr[$i]['no'] = $filedata[0];
                                $importData_arr[$i]['ques'] = $filedata[1];
                                $importData_arr[$i]['opta'] = $filedata[2];
                                $importData_arr[$i]['optb'] = $filedata[3];
                                $importData_arr[$i]['optc'] = $filedata[4];
                                $importData_arr[$i]['optd'] = $filedata[5];
                                $importData_arr[$i]['opte'] = $filedata[6];
                                $importData_arr[$i]['Ans'] = $filedata[7];
                            }
                            $i++;
                        }
                        fclose($file);
                        // Insert data
                        // $count = 0;
                        $data = [
                            'imports' => $importData_arr
                        ];
                        echo view('admin/include/header', $data);
                        echo view('admin/file-preview');
                        echo view('admin/include/footer');

                        // foreach ($importData_arr as $userdata) {
                        //     echo '<tr><td>' . $userdata['_group'] . '</td></tr>';
                        //     // $users = new Users();
                        //     // // Check record
                        //     // $checkrecord = $users->where('email', $userdata['email'])->countAllResults();
                        //     // if ($checkrecord == 0) {
                        //     //     ## Insert Record
                        //     //     if ($users->insert($userdata)) {
                        //     //         $count++;
                        //     //     }
                        //     // }
                        // }

                        return;
                    }
                }
            }
        }
        echo view('admin/include/header');
        echo view('admin/load-method');
        echo view('admin/include/footer');
    }

    public function file_loader()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        if (!session()->get('type') || !session()->get('session') || !session()->get('class') || !session()->get('term') || !session()->get('subject')) {
            return redirect()->to(base_url() . '/admin/exam/load_question');
        }
        helper(['form', 'text']);
        $request = \Config\Services::request();
        //checking for a request below

        if ($request->getMethod() == 'post') {
            //Initialize Models
            $ques_details = new Question_details();
            $questions = new Questions();

            //Check if question already exists
            $checkQues = $ques_details->where('Qsession', session()->get('session'))
                ->where('Qclass', session()->get('class'))
                ->where('Qterm', session()->get('term'))
                ->where('Qtype', session()->get('type'))
                ->where('subject', session()->get('subject'))
                ->where('school_id', session()->get('schid'))
                ->first();

            if ($checkQues) {
                $session = session();
                $session->setFlashdata('Qerror', 'Error: Question already exists!');
                return redirect()->to(base_url() . '/admin/exam/load_question');
            }

            //
            $count = $request->getVar('counter');
            $Qid = rand();
            $data = []; //empty array to save questions
            //
            for ($i = 1; $i <= $count; $i++) {
                $quest = $request->getVar('q' . $i);
                $opta = $request->getVar('op' . $i . 'a');
                $optb = $request->getVar('op' . $i . 'b');
                $optc = $request->getVar('op' . $i . 'c');
                $optd = $request->getVar('op' . $i . 'd');
                $opte = $request->getVar('op' . $i . 'e');
                $ans = $request->getVar('ans' . $i);

                if ($questions->save([
                    'Qid' => $Qid,
                    'Qno' => $i,
                    'question' => $quest,
                    'optA' => $opta,
                    'optB' => $optb,
                    'optC' => $optc,
                    'optD' => $optd,
                    'optE' => $opte,
                    'ans' => $ans
                ]) && $i == $count) {
                    $ques_details->save([
                        'school_id' => session()->get('schid'),
                        'Qid' => $Qid,
                        'Qsession' => session()->get('session'),
                        'Qclass' => session()->get('class'),
                        'Qterm' => session()->get('term'),
                        'Qtype' => session()->get('type'),
                        'subject' => session()->get('subject'),
                        'addedOn' => new Time('now'),
                        'approved' => 0
                    ]);

                    $session = session();
                    $session->setFlashdata('success', session()->get('subject') . ' Questions has been loaded successfuly');

                    return redirect()->to(base_url() . '/admin/exam/load_question');
                }

                //if its the last question, save the question details
            }
        }

        echo view('admin/include/header');
        echo view('admin/file-preview');
        echo view('admin/include/footer');
    }

    public function manual()
    {
        return redirect()->to(base_url());
        echo view('admin/include/header');
        echo view('admin/manual-load');
        echo view('admin/include/footer');
    }

    public function settings()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        $error = '';
        $success = '';
        $request = \Config\Services::request();
        $exam = new Exams();

        if ($request->getMethod() == 'post') {
            $term = $request->getVar('term');
            $class = $request->getVar('class');
            $session = $request->getVar('session');
            $subject = $request->getVar('subject');
            $type = $request->getVar('examtype');
            $date = $request->getVar('date');
            //
            if ($term != '' && $class != '' && $session != '' && $subject != '' && $type != '') {
                $quest = new Question_details();
                $checker = $quest->where('Qsession', $session)
                    ->where('Qterm', $term)
                    ->where('Qclass', $class)
                    ->where('Qtype', $type)
                    ->where('subject', $subject)
                    ->first();

                if (!$checker) {
                    $error = 'ERROR: There is no Question for this exam. Kindly upload questions';
                } else {
                    $checker = $exam->where('examClass', $class)
                        ->where('examSession', $session)
                        ->where('examTerm', $term)
                        ->where('examSubject', $subject)
                        ->where('examType', $type)
                        ->where('school_id', session()->get('schid'))
                        ->first();

                    if (!$checker) {

                        $setData = [
                            'school_id' => session()->get('schid'),
                            'examClass' => $class,
                            'examSession' => $session,
                            'examTerm' => $term,
                            'examSubject' => $subject,
                            'examType' => $type,
                            'examDate' => $date,
                            'examCode' => rand(),
                            'examStatus' => 'waiting'
                        ];

                        if ($exam->save($setData)) {
                            $resultFlag = new Resultflag();

                            $checker = $resultFlag->where('school_id', 'SCHOOL01')
                                ->where('_session', $session)
                                ->where('term', $term)
                                ->where('class', $class)
                                ->where('examStatus', $type)
                                ->first();

                            //
                            if (!$checker) {

                                $flagData = [
                                    'school_id' => 'SCHOOL01',
                                    '_session' => $session,
                                    'term'  => $term,
                                    'class' => $class,
                                    'examStatus'  => $type,
                                    'published' => 'false',
                                    'addedOn' => new Time('now')
                                ];

                                $resultFlag->save($flagData);
                            }
                            $success = $subject . ' examination for ' . $class . ' have been scheduled';
                        }
                    } else {
                        $error = "ERROR: This Exam is already scheduled";
                    }
                }
            }
        }

        //........................................................
        $classes = new Classes();
        $subjects = new Subjects();
        $examModel = new Exams();
        //
        $cbuilder = $classes->builder();
        $sbuilder = $subjects->builder();
        $examBuilder = $examModel->builder();
        //
        $cbuilder->select('*');
        $cbuilder->where('school_id', session()->get('schid'));
        $allclass = $cbuilder->get()->getResult();
        //
        $sbuilder->select('*');
        $sbuilder->where('school_id', session()->get('schid'));
        $allsubject = $sbuilder->get()->getResult();
        //
        $examBuilder->select('*');
        $examBuilder->where('school_id', session()->get('schid'));
        $examBuilder->where('examStatus', 'waiting');
        $getList = $examBuilder->get()->getResult();

        $data = [
            'classes' => $allclass,
            'subjects' => $allsubject,
            'error' => $error,
            'success' => $success,
            'schedules' => $getList
        ];
        echo view('admin/include/header', $data);
        echo view('admin/exam/set-exam');
        echo view('admin/include/footer');
    }
    
    //
    public function viewResult()
    {
        $scores = new Scores();
        $classes = new Classes();
        //

        $request = \Config\Services::request();
        //
        if ($request->getMethod() == 'post') {
            //
            $class = $request->getVar('class');
            $term = $request->getVar('term');
            $type = $request->getVar('type');
            //
            $getScores = $scores->where('scores.class', $class)
                ->where("scores.term", $term)
                ->where("scores.examType", $type)
                ->join('stud', "scores.student_id = stud.regid")
                ->where('scores.school_id', session()->get('schid'))
                ->distinct()
                ->orderBy('scores.id', 'DESC')->findAll();
        } else {

            $getScores = $scores->join('stud', "scores.student_id = stud.regid")
                ->where('scores.school_id', session()->get('schid'))
                ->distinct()
                ->orderBy('scores.id', 'DESC')->findAll();
        }

        //
        $getClass = $classes->where('school_id', session()->get('schid'))->findAll();

        //
        $data = [
            'scores' => $getScores,
            'classes' => $getClass
        ];

        echo view('admin/include/header', $data);
        echo view('admin/exam/viewResult');
        echo view('admin/include/footer');
    }
}
