<?php

namespace App\Controllers\Admin;

use App\Controllers\BaseController;
use CodeIgniter\I18n\Time;
use App\Models\Resultflag;
use App\Models\Result;
use App\Models\Scores;
use App\Models\Subjects;
use App\Models\Staffs;

class Results extends BaseController
{
    public function index()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        $resultflag = new Resultflag();

        $flagBuilder = $resultflag->builder();
        //
        $flagBuilder->select('*');
        $flagBuilder->where('school_id', 'SCHOOL01');
        $flagBuilder->where('published', 'false');
        $getFlag = $flagBuilder->get()->getResult();

        //
        $data = [
            'flags' => $getFlag
        ];
        echo view('admin/include/header', $data);
        echo view('admin/exam/results');
        echo view('admin/include/footer');
    }

    //Exam Publisher
    public function publisher()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        $request = \Config\Services::request();
        //
        if ($request->getMethod() == 'get') {
            if ($request->getVar('id') && $request->getVar('publish') == true) {

                //
                $id = $request->getVar('id');
                $sid = $request->getVar('sid');
                $resultflag = new Resultflag();
                $result = new Result();

                //
                $flag = $resultflag->where('id', $id)->where('published', 'false')->where('school_id', $sid)->first();

                if ($flag) {

                    $scores = new Scores();
                    //
                    $sbuilder = $scores->builder();
                    //
                    $sbuilder->select('*');
                    $sbuilder->where('school_id', $flag['school_id']);
                    $sbuilder->where('sesion', $flag['_session']);
                    $sbuilder->where('term', $flag['term']);
                    $sbuilder->where('class', $flag['class']);
                    $sbuilder->where('examType', $flag['examStatus']);
                    $getScores = $sbuilder->get()->getResult();

                    //
                    if ($getScores) {
                        $subjects = new Subjects();
                        $staffs = new Staffs();

                        foreach ($getScores as $score) {
                            $getSubTechId = $subjects->where('school_id', $score->school_id)
                                ->where('subject_name', $score->subject)->first();

                            if ($getSubTechId) {
                                $getTecher = $staffs->where('staff_id', $getSubTechId['subject_teacher'])->first();
                            }

                            $data = [

                                'school_id' => $score->school_id,
                                'student_id' => $score->student_id,
                                'sesion' => $score->sesion,
                                'term' => $score->term,
                                'class' => $score->class,
                                'examType' => $score->examType,
                                'subject' => $score->subject,
                                'ca' => $score->CAScore,
                                'exam' => $score->final_exam_score,
                                'total' => $score->CAScore + $score->final_exam_score,
                                'position',
                                'grade',
                                'remark',
                                'teacher' => $getTecher['lname'] . ' ' . $getTecher['fname'],
                                'publishedOn' => new Time('now'),
                            ];
                        }
                    }
                }
            }
        }
    }
}
