<?php

namespace App\Controllers\Admin;

use App\Controllers\BaseController;
use App\Models\Students;

class Student extends BaseController
{
    public function index()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        echo view('admin/include/header');
        echo view('admin/index');
        echo view('admin/include/footer');
    }

    public function create()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }

        $data = [];
        helper(['form', 'text']);
        $request = \Config\Services::request();

        if ($request->getMethod() == 'post') {

            //initialize model (database ==> students db)
            $studentsdb = new Students();

            //Set validation rules for datas
            $rules = [
                'firstname' => 'required',
                'surname' => 'required',
                'email' => 'required|valid_email',
                'date' => 'required',
                'sorigin' => 'required',
                'lgaorigin' => 'required',
                'torigin' => 'required',
                'pname' => 'required',
                'pnumber' => 'required',
                'pemail' => 'required',
                'mstatus' => 'required',
                'eclass' => 'required',
                'home_address' => 'required|min_length[8]',
                'r_address' => 'required|min_length[5]',
                'about' => 'required|min_length[10]'
            ];

            //Set validation errors for datas
            $errors = [
                'firstname' => [
                    'required' => 'Your first name is required'
                ],
                'surname' => [
                    'required' => 'Your surname is required'
                ],
                'home_address' => [
                    'min_length' => 'Please enter your complete Home Address'
                ],
                'r_address' => [
                    'min_length' => 'Please enter your complete Residential Address'
                ]
            ];

            //if successfull validation
            if ($this->validate($rules, $errors)) {

                $passport = $request->getFile('file-passport');

                if ($passport->getSize() > 0) {
                    $name = $passport->getRandomName();

                    $passport->move('./uploads/passports/', $name);
                }

                $students_data = [
                    'regno' => $request->getVar('regno'),
                    'eclass' => $request->getVar('eclass'),
                    'mstatus' => $request->getVar('mstatus'),
                    'poccupation' => $request->getVar('poccupation'),
                    'fname' => $request->getVar('firstname'),
                    'mname' => $request->getVar('middlename'),
                    'lname' => $request->getVar('surname'),
                    'dob' => $request->getVar('date'),
                    'nationality' => $request->getVar('nationality'),
                    'sorigin' => $request->getVar('sorigin'),
                    'lga' => $request->getVar('lgaorigin'),
                    'town' => $request->getVar('torigin'),
                    'home_address' => $request->getVar('home_address'),
                    'r_address' => $request->getVar('r_address'),
                    'email' => $request->getVar('email'),
                    'phone' => $request->getVar('phone'),
                    'parent' => $request->getVar('pname'),
                    'parent_email' => $request->getVar('pemail'),
                    'parent_number' => $request->getVar('pnumber'),
                    'passportURL' => $name
                ];

                // if (session()->get('lname')) {
                //     session_destroy();
                //     session()->set($students_data);
                // } else {
                //     session()->set($students_data);
                // }

                // return redirect()->to(base_url() . '/admin/student/preview');

                if ($studentsdb->save($students_data)) {

                    $session = session();
                    $session->setFlashdata('success', 'Student successfully created');
                }
            } else {
                $data['validation'] = $this->validator;
            }
        }


        echo view('admin/include/header', $data);
        echo view('admin/create-student');
        echo view('admin/include/footer');
    }

    public function preview()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') > 2 || $session->get('auth') < 1) {

            return redirect()->to(base_url());
        }
        echo view('admin/include/header');
        echo view('admin/form-preview');
        echo view('admin/include/footer');
    }
}
