<?php

namespace App\Controllers\Exam;

use App\Models\Questions;
use App\Models\Question_details;
use App\Models\Examgraph;
use App\Models\Scores;
use \CodeIgniter\I18n\Time;

use App\Controllers\BaseController;

class Start extends BaseController
{
    public function index()
    {
        if (!session()->get('startExam')) {
            throw \CodeIgniter\Exceptions\PageNotFoundException::forPageNotFound();
        } else {

            $examCode = session()->get('examCode');
            $regNo = session()->get('regno');
            $sesion = session()->get('session');
            $class = session()->get('class');
            $term = session()->get('term');
            $subject = session()->get('subject');
            $type = session()->get('type');
            //
            $Qdetails = new Question_details();
            $Questions = new Questions();
            //

            $checker = $Qdetails->where('school_id', session()->get('schid'))
                ->where('Qsession', $sesion)
                ->where('Qterm', $term)
                ->where('Qclass', $class)
                ->where('subject', $subject)
                ->where('Qtype', $type)
                ->first();

            if (!$checker) {
                return redirect()->to(base_url() . '/students');
            } else {
                $Qbuilder = $Questions->builder();
                //
                $Qbuilder->select('*');
                $Qbuilder->where('Qid', $checker['Qid']);
                $loadQuestions = $Qbuilder->get()->getResult();

                //Load to view
                $data = [
                    'questions' => $loadQuestions
                ];
                //

                return view('exam', $data);
            }
        }
    }

    //Exam graph.........Kepps tracks of students answers and correct answers.
    public function examGraph()
    {
        $request = \Config\Services::request();
        //check for a request
        if ($request->getMethod() == 'post' && $request->getVar('examGraph') == true) {
            //
            helper(['form', 'text']);
            $questions = new Questions();
            $examGraph = new Examgraph();
            $score = 0;
            //
            //Check if question have ben answered before
            $gchecker = $examGraph->where('school_id', $request->getVar('schoolID'))
                ->where('student_id', $request->getVar('studentID'))
                ->where('examType', $request->getVar('examType'))
                ->where('examSession', $request->getVar('session'))
                ->where('examTerm', $request->getVar('term'))
                ->where('subject', $request->getVar('subject'))
                ->where('quesNo', $request->getVar('qno'))
                ->first();

            if ($gchecker) {

                if ($request->getVar('sans') == $gchecker['correctAns']) {
                    $score = 2;
                } else {
                    $score = 0;
                }

                $data_sub = [
                    'id' => $gchecker['id'],
                    'studentAns' => $request->getVar('sans'),
                    'score' => $score
                ];

                //finally Update examResultGraph
                if ($examGraph->save($data_sub)) {
                    echo 100;
                } else {
                    echo 200;
                }
            } else {

                //check question answer from question table.
                $checker = $questions->where('Qid', $request->getVar('qid'))
                    ->where('Qno', $request->getVar('qno'))
                    ->first();
                //
                if ($request->getVar('sans') == $checker['ans']) {
                    $score = 2;
                } else {
                    $score = 0;
                }
                //
                $data_sub = [
                    'school_id' => $request->getVar('schoolID'),
                    'student_id' => $request->getVar('studentID'),
                    'examDate' => $request->getVar('examDate'),
                    'examType' => $request->getVar('examType'),
                    'examSession' => $request->getVar('session'),
                    'examTerm' => $request->getVar('term'),
                    'examClass' => $request->getVar('class'),
                    'subject' => $request->getVar('subject'),
                    'quesNo' => $request->getVar('qno'),
                    'studentAns' => $request->getVar('sans'),
                    'correctAns' => $checker['ans'],
                    'score' => $score,
                    'addedOn' => $request->getVar('ison')
                ];

                //finally submit examResultGraph
                if ($examGraph->save($data_sub)) {
                    echo 100;
                } else {
                    echo 200;
                }
            }
        }
    }

    //submit exam

    public function finishExam()
    {
        helper(['form']);
        $request = \Config\Services::request();
        //
        if ($request->getMethod() == 'post' && $request->getVar('submitPaper') == true) {
            //Instantiate Models
            $examGraph = new Examgraph();
            $scores = new Scores();
            //
            $gbuilder = $examGraph->builder();
            //
            $gbuilder->selectSum('score');
            $gbuilder->where('school_id', $request->getVar('schoolID'));
            $gbuilder->where('student_id', $request->getVar('studentID'));
            $gbuilder->where('examType', $request->getVar('examType'));
            $gbuilder->where('examSession', $request->getVar('session'));
            $gbuilder->where('examTerm', $request->getVar('term'));
            $gbuilder->where('subject', $request->getVar('subject'));
            $fetchResult = $gbuilder->get()->getResult();

            //
            if ($fetchResult) {

                $sc_data = [
                    'school_id' => $request->getVar('schoolID'),
                    'student_id' => $request->getVar('studentID'),
                    'sesion' => $request->getVar('session'),
                    'term' => $request->getVar('term'),
                    'class' => $request->getVar('class'),
                    'examType' => $request->getVar('examType'),
                    'subject' => $request->getVar('subject'),
                    'examScore' => $fetchResult[0]->score,
                    'addedOn' => new Time('now')
                ];

                if ($scores->save($sc_data)) {

                    echo 100;
                } else {
                    echo 200;
                }
            }
        }
    }
}
