<?php

namespace App\Controllers\Students;

use App\Controllers\BaseController;
use App\Models\Exams;
use App\Models\Questions;
use DateTime;

class Exam extends BaseController
{
    public function index()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') != 5) {

            return redirect()->to(base_url());
        }
        echo view('protected/header');
        echo view('students/exam');
        echo view('protected/footer');
    }

    public function examcheck()
    {
        $session = session();
        if (!$session->get('schid') || !$session->get('regid') || !$session->get('auser') || $session->get('auth') != 5) {

            return redirect()->to(base_url());
        }

        $request = \Config\Services::request();
        //
        if ($request->getMethod() == 'post') {
            //
            helper(['form', 'text']);
            //
            $code = $request->getVar('code');
            $regno = $request->getVar('regno');
            //
            $exams = new Exams();
            $date = new DateTime();
            //
            $checker = $exams->where('examCode', $code)
                ->where('examStatus', 'waiting')
                ->first();

            if ($checker) {
                $currentDate = $date->format('Y-m-d');
                $saveDate = new DateTime($currentDate);
                $examDate = new DateTime($checker['examDate']);
                $interval = $saveDate->diff($examDate);
                $examDateStatus = $interval->format('%R%a');
                //
                if ($examDateStatus < 0) {
                    $session = session();
                    $session->setFlashdata('checkError', 'Error: This exam have been written. Kindly contact school admin');
                } else if ($examDateStatus > 0) {
                    $session = session();
                    $session->setFlashdata('checkNotice', 'This Exam comes up in ' . $examDateStatus . ' days');
                } else {
                    $examToWrite = [
                        'regno' => $regno,
                        'examCode' => $code,
                        'session' => $checker['examSession'],
                        'term' => $checker['examTerm'],
                        'class' => $checker['examClass'],
                        'subject' => $checker['examSubject'],
                        'type' => $checker['examType'],
                        'startExam' => true
                    ];

                    //
                    session()->set($examToWrite);
                    //
                    if (session()->get('startExam')) {
                        $url = '' . base_url() . '/exam/start';
                        return "<script>window.open('$url', 'Examination', 'width=1300,height=800');</script>" . PHP_EOL;

                        // redirect()->to(base_url() . '/exam/start');
                    }
                }
            } else {
                $session = session();
                $session->setFlashdata('checkError', 'Invalid examination code');
            }
        }
        echo view('protected/header');
        echo view('students/exam-check');
        echo view('protected/footer');
    }
}
